function input_best = Golden_Section_Search(func_handle , input_min , input_max)

% input_best = Golden_Section_Search(func_handle , input_min , input_max)
%
% The function implements the golden section search for finding the
% minimizer of a cost function. The objective function is given as a handle
% along with the the search interval [input_min , input_max]

ratio           = (3 - sqrt(5)) / 2;
cost_Intrv_Th   = (input_max - input_min) / 1e3;

input_vec       = input_min + input_max * [0  ratio  1-ratio  1];
cost_vec        = [func_handle(input_vec(1))    func_handle(input_vec(2))  ...
                   func_handle(input_vec(3))    func_handle(input_vec(4))];

while (cost_vec(4) - cost_vec(1)) > cost_Intrv_Th
    if ismember(min(cost_vec) , cost_vec(1:3))
        cost_vec    = cost_vec(1) + (cost_vec(3) - cost_vec(1)) * [0  ratio  1-ratio  1];
        input_vec   = [input_vec(1)  func_handle(input_vec(2))  input_vec(2 : 3)];
    else
        cost_vec    = cost_vec(2) + (cost_vec(4) - cost_vec(2)) * [0  ratio  1-ratio  1];
        input_vec   = [input_vec(2 : 3)  func_handle(coef_vec(3))  input_vec(4)];
    end
end

input_best      = input_vec(input_vec == max(input_vec)); 
input_best      = input_best(1);