% refreshing the GUI


% Process-Type Panel
set(handles.ProcessType_Panel               , 'ForegroundColor' , 'k')
set(handles.Gaussian_RadioButton            , 'Enable' , 'on')
set(handles.Laplace_RadioButton             , 'Enable' , 'on')
set(handles.Poisson_RadioButton             , 'Enable' , 'on')
set(handles.Students_RadioButton            , 'Enable' , 'on')
set(handles.alpha_RadioButton               , 'Enable' , 'on')

switch handles.Dist_Sel
    case 1      % Gaussian
        handles.Prior_Type  = 1;
        
        set(handles.GaussianVar_Text                , 'Enable' , 'on' )
        set(handles.GaussianVar_ValText             , 'Enable' , 'on')
        set(handles.Laplaceb_Text                   , 'Enable' , 'off')
        set(handles.Laplaceb_ValText                , 'Enable' , 'off')
        set(handles.PoissonMassP_Text               , 'Enable' , 'off')
        set(handles.PoissonMass_Text                , 'Enable' , 'off')
        set(handles.Studentsq_Text                  , 'Enable' , 'off')
        set(handles.Studentsq_ValText               , 'Enable' , 'off')
        set(handles.alpha_stext                     , 'Enable' , 'off')
        set(handles.alpha_slider                    , 'Enable' , 'off')
        set(handles.alpha_ShowText                  , 'Enable' , 'off')
        
        set(handles.PoissonAmp_Panel                , 'ForegroundColor' , [0.5,0.5,0.5])
        set(handles.Poisson_Gaussian_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_GaussianVar_Text        , 'Enable' , 'off')
        set(handles.Poisson_Laplace_RadioButton     , 'Enable' , 'off')
        set(handles.Poisson_Laplaceb_Text           , 'Enable' , 'off')
        set(handles.Poisson_Students_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_Studentsq_Text          , 'Enable' , 'off')
        
        if pnumcheck(handles.Gauss_var)&integercheck(handles.SS_length)&pnumcheck(handles.Noise_Var)
            handles.Dist_Param  = handles.Gauss_var;
            handles.SigGen_En   = 1;
        else
            handles.SigGen_En   = 0;
        end

        
        
    case 2      % Laplace
        handles.Prior_Type  = 1;
        
        set(handles.GaussianVar_Text                , 'Enable' , 'off')
        set(handles.GaussianVar_ValText             , 'Enable' , 'off')
        set(handles.Laplaceb_Text                   , 'Enable' , 'on')
        set(handles.Laplaceb_ValText                , 'Enable' , 'on')
        set(handles.PoissonMassP_Text               , 'Enable' , 'off')
        set(handles.PoissonMass_Text                , 'Enable' , 'off')
        set(handles.Studentsq_Text                  , 'Enable' , 'off')
        set(handles.Studentsq_ValText               , 'Enable' , 'off')
        set(handles.alpha_stext                     , 'Enable' , 'off')
        set(handles.alpha_slider                    , 'Enable' , 'off')
        set(handles.alpha_ShowText                  , 'Enable' , 'off')
        
        set(handles.PoissonAmp_Panel                , 'ForegroundColor' , [0.5,0.5,0.5])
        set(handles.Poisson_Gaussian_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_GaussianVar_Text        , 'Enable' , 'off')
        set(handles.Poisson_Laplace_RadioButton     , 'Enable' , 'off')
        set(handles.Poisson_Laplaceb_Text           , 'Enable' , 'off')
        set(handles.Poisson_Students_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_Studentsq_Text          , 'Enable' , 'off')
        
        if pnumcheck(handles.Lap_b)&integercheck(handles.SS_length)&pnumcheck(handles.Noise_Var)
            handles.Dist_Param  = handles.Lap_b;
            handles.SigGen_En   = 1;
        else
            handles.SigGen_En   = 0;
        end
        
                
        
    case 3      % Poisson
        handles.Prior_Type  = 2;
        
        set(handles.GaussianVar_Text                , 'Enable' , 'off')
        set(handles.GaussianVar_ValText             , 'Enable' , 'off')
        set(handles.Laplaceb_Text                   , 'Enable' , 'off')
        set(handles.Laplaceb_ValText                , 'Enable' , 'off')
        set(handles.PoissonMassP_Text               , 'Enable' , 'on' )
        set(handles.PoissonMass_Text                , 'Enable' , 'on' )
        set(handles.Studentsq_Text                  , 'Enable' , 'off')
        set(handles.Studentsq_ValText               , 'Enable' , 'off')
        set(handles.alpha_stext                     , 'Enable' , 'off')
        set(handles.alpha_slider                    , 'Enable' , 'off')
        set(handles.alpha_ShowText                  , 'Enable' , 'off')
        
        set(handles.PoissonAmp_Panel                , 'ForegroundColor' , 'k')
        set(handles.Poisson_Gaussian_RadioButton    , 'Enable' , 'on')
        set(handles.Poisson_Laplace_RadioButton     , 'Enable' , 'on')
        set(handles.Poisson_Students_RadioButton    , 'Enable' , 'on')
        
        switch handles.P_Dist_Sel
            case 1
                set(handles.Poisson_GaussianVar_Text    , 'Enable' , 'on')
                set(handles.Poisson_Laplaceb_Text       , 'Enable' , 'off')
                set(handles.Poisson_Studentsq_Text      , 'Enable' , 'off')
                
                if pnumcheck(handles.MassProb)&pnumcheck(handles.Pois_G_var)&integercheck(handles.SS_length)&pnumcheck(handles.Noise_Var)
                	if handles.MassProb <= 1
                        handles.Dist_Param  = handles.Pois_G_var;
                        handles.SigGen_En   = 1;
                    else
                        handles.SigGen_En   = 0;
                    end
                else
                    handles.SigGen_En       = 0;
                end
                
                
            case 2
                set(handles.Poisson_GaussianVar_Text    , 'Enable' , 'off')
                set(handles.Poisson_Laplaceb_Text       , 'Enable' , 'on')
                set(handles.Poisson_Studentsq_Text      , 'Enable' , 'off')
                
                if pnumcheck(handles.MassProb)&pnumcheck(handles.Pois_Lap_b)&integercheck(handles.SS_length)&pnumcheck(handles.Noise_Var)
                	if handles.MassProb <= 1
                        handles.Dist_Param  = handles.Pois_Lap_b;
                        handles.SigGen_En   = 1;
                    else
                        handles.SigGen_En   = 0;
                    end
                else
                    handles.SigGen_En       = 0;
                end
                
                
            case 3
                set(handles.Poisson_GaussianVar_Text    , 'Enable' , 'off')
                set(handles.Poisson_Laplaceb_Text       , 'Enable' , 'off')
                set(handles.Poisson_Studentsq_Text      , 'Enable' , 'on')
                
                if pnumcheck(handles.MassProb)&pnumcheck(handles.Pois_Stud_q)&integercheck(handles.SS_length)&pnumcheck(handles.Noise_Var)
                	if handles.MassProb <= 1
                        handles.Dist_Param  = handles.Pois_Stud_q;
                        handles.SigGen_En   = 1;
                    else
                        handles.SigGen_En   = 0;
                    end
                else
                    handles.SigGen_En       = 0;
                end
                
                
        end
        

        
    case 4      % Student's t
        handles.Prior_Type  = 1;
        
        set(handles.GaussianVar_Text                , 'Enable' , 'off')
        set(handles.GaussianVar_ValText             , 'Enable' , 'off')
        set(handles.Laplaceb_Text                   , 'Enable' , 'off')
        set(handles.Laplaceb_ValText                , 'Enable' , 'off')
        set(handles.PoissonMassP_Text               , 'Enable' , 'off')
        set(handles.PoissonMass_Text                , 'Enable' , 'off')
        set(handles.Studentsq_Text                  , 'Enable' , 'on' )
        set(handles.Studentsq_ValText               , 'Enable' , 'on')
        set(handles.alpha_stext                     , 'Enable' , 'off')
        set(handles.alpha_slider                    , 'Enable' , 'off')
        set(handles.alpha_ShowText                  , 'Enable' , 'off')
        
        set(handles.PoissonAmp_Panel                , 'ForegroundColor' , [0.5,0.5,0.5])
        set(handles.Poisson_Gaussian_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_GaussianVar_Text        , 'Enable' , 'off')
        set(handles.Poisson_Laplace_RadioButton     , 'Enable' , 'off')
        set(handles.Poisson_Laplaceb_Text           , 'Enable' , 'off')
        set(handles.Poisson_Students_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_Studentsq_Text          , 'Enable' , 'off')
        
        if pnumcheck(handles.Stud_q)&integercheck(handles.SS_length)&pnumcheck(handles.Noise_Var)
            handles.Dist_Param  = handles.Stud_q;
            handles.SigGen_En   = 1;
        else
            handles.SigGen_En   = 0;
        end
        


    case 5      % alpha Stable
        handles.Prior_Type  = 1;
        
        set(handles.GaussianVar_Text                , 'Enable' , 'off')
        set(handles.GaussianVar_ValText             , 'Enable' , 'off')
        set(handles.Laplaceb_Text                   , 'Enable' , 'off')
        set(handles.Laplaceb_ValText                , 'Enable' , 'off')
        set(handles.PoissonMassP_Text               , 'Enable' , 'off')
        set(handles.PoissonMass_Text                , 'Enable' , 'off')
        set(handles.Studentsq_Text                  , 'Enable' , 'off')
        set(handles.Studentsq_ValText               , 'Enable' , 'off')
        set(handles.alpha_stext                     , 'Enable' , 'on')
        set(handles.alpha_slider                    , 'Enable' , 'on')
        set(handles.alpha_ShowText                  , 'Enable' , 'on')
        
        set(handles.PoissonAmp_Panel                , 'ForegroundColor' , [0.5,0.5,0.5])
        set(handles.Poisson_Gaussian_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_GaussianVar_Text        , 'Enable' , 'off')
        set(handles.Poisson_Laplace_RadioButton     , 'Enable' , 'off')
        set(handles.Poisson_Laplaceb_Text           , 'Enable' , 'off')
        set(handles.Poisson_Students_RadioButton    , 'Enable' , 'off')
        set(handles.Poisson_Studentsq_Text          , 'Enable' , 'off')
        
        if pnumcheck(handles.Stable_alph)&integercheck(handles.SS_length)&pnumcheck(handles.Noise_Var)
            handles.Dist_Param  = handles.Stable_alph;
            handles.SigGen_En   = 1;
        else
            handles.SigGen_En   = 0;
        end
        
        
end



% Signal Generate button
switch handles.SigGen_En
    case 0
        set(handles.SigGen_PushButton , 'Enable' , 'off' , 'BackgroundColor' , [.9,.9,.9])
        handles.SigGenerated    = 0;
        
    case 1
        set(handles.SigGen_PushButton , 'Enable' , 'on'  , 'BackgroundColor' , [0,1,0])
        set(handles.SigGen_PushButton , 'BackgroundColor' , [0.9,0.9,0])
        set(handles.SigGen_PushButton , 'BackgroundColor' , [0,1,0])
end


% Export to Workspace button
switch handles.SigGenerated
    case 0
        set(handles.SigGenExp2WrkSpc_PushButton , 'Enable' , 'off' , 'BackgroundColor' , [.9,.9,.9])
        
    case 1
        set(handles.SigGenExp2WrkSpc_PushButton , 'Enable' , 'on'  , 'BackgroundColor' , [0,1,0])
end



% The figure in the GUI
if ~handles.SigGenerated
    imshow(handles.Def_Im_Name)
end



% Simulation's Parameters Panel
set(handles.SimParam_Panel                  , 'ForegroundColor' , 'k')
set(handles.SigLength_Text                  , 'Enable' , 'on')
set(handles.AWGNvar_Text                    , 'Enable' , 'on')
set(handles.SystemOrder_Text                , 'Enable' , 'on')
set(handles.SigLength_ValText               , 'Enable' , 'on')
set(handles.AWGNvar_ValText                 , 'Enable' , 'on')
set(handles.Operator_Popup                  , 'Enable' , 'on')



% Animation Panel
if handles.SigGenerated
    set(handles.Animation_Panel  , 'ForegroundColor' , 'k')
    if handles.Operator > 1
        set(handles.MMSE_RadioButton    , 'Enable'      , 'off')
        if handles.AnimMethod == 1
            set(handles.MMSE_RadioButton    , 'Value'      , 0)
            set(handles.LMMSE_RadioButton   , 'Value'      , 1)
            handles.AnimMethod      = 2;
        end
        set(handles.Log_RadioButton     , 'Enable'      , 'on')
        set(handles.LMMSE_RadioButton   , 'Enable'      , 'on')
        set(handles.L1_RadioButton      , 'Enable'      , 'on')
    else
        set(handles.MMSE_RadioButton    , 'Enable'      , 'on')
        set(handles.Log_RadioButton     , 'Enable'      , 'on')
        set(handles.LMMSE_RadioButton   , 'Enable'      , 'on')
        set(handles.L1_RadioButton      , 'Enable'      , 'on')
    end
    
    if handles.AnimMethod == 1
        set(handles.lambdaAnim_Text     , 'Enable'          , 'off')
        set(handles.lambdaAnim_ValText  , 'Enable'          , 'off')
    else
        set(handles.lambdaAnim_Text     , 'Enable'          , 'on')
        set(handles.lambdaAnim_ValText  , 'Enable'          , 'on')
    end
    
else
    set(handles.Animation_Panel     , 'ForegroundColor' , [0.5,0.5,0.5])
    set(handles.MMSE_RadioButton    , 'Enable'          , 'off')
    set(handles.Log_RadioButton     , 'Enable'          , 'off')
    set(handles.LMMSE_RadioButton   , 'Enable'          , 'off')
    set(handles.L1_RadioButton      , 'Enable'          , 'off')
    
    set(handles.lambdaAnim_Text     , 'Enable'          , 'off')
    set(handles.lambdaAnim_ValText  , 'Enable'          , 'off')
end



% Animation Push button
if (handles.SigGenerated == 1)&(pnumcheck(handles.AnimLambda)||(handles.AnimMethod == 1))
    set(handles.Animation_PushButton    , 'Enable' , 'on'  , 'BackgroundColor' , [0,1,0])
else
    set(handles.Animation_PushButton    , 'Enable' , 'off' , 'BackgroundColor' , [0.9,0.9,0.9])
end



% Method Selection Panel
if handles.SigGen_En
    set(handles.MethodSelection_Panel   , 'ForegroundColor' , 'k')
    if handles.Operator > 1
        set(handles.MMSE_CheckBox       , 'Enable'          , 'off')
        set(handles.MMSE_CheckBox       , 'Value'           , [0]  )
        set(handles.log_CheckBox        , 'Enable'          , 'on' )
        set(handles.LMMSE_CheckBox      , 'Enable'          , 'on' )
        set(handles.L1_CheckBox         , 'Enable'          , 'on' )
        handles.MethodEn(1)     = 0;
    else
        set(handles.MMSE_CheckBox       , 'Enable'          , 'on' )
        set(handles.log_CheckBox        , 'Enable'          , 'on' )
        set(handles.LMMSE_CheckBox      , 'Enable'          , 'on' )
        set(handles.L1_CheckBox         , 'Enable'          , 'on' )
    end
    
else
    set(handles.MethodSelection_Panel   , 'ForegroundColor' , [0.5,0.5,0.5])
    set(handles.MMSE_CheckBox           , 'Enable'          , 'off')
    set(handles.MMSE_CheckBox           , 'Value'           , [0])
    set(handles.log_CheckBox            , 'Enable'          , 'off')
    set(handles.log_CheckBox            , 'Value'           , [0])
    set(handles.LMMSE_CheckBox          , 'Enable'          , 'off')
    set(handles.LMMSE_CheckBox          , 'Value'           , [0])
    set(handles.L1_CheckBox             , 'Enable'          , 'off')
    set(handles.L1_CheckBox             , 'Value'           , [0])
    handles.MethodEn            = 0 * handles.MethodEn;
    
end
if handles.MethodEn(2)&(handles.SigGenerated)
    set(handles.lambda_LMMSE_Text       , 'Enable'          , 'on' )
    set(handles.lambdaLMMSE_ValText     , 'Enable'          , 'on' )
else
    set(handles.lambda_LMMSE_Text       , 'Enable'          , 'off')
    set(handles.lambdaLMMSE_ValText     , 'Enable'          , 'off')
end
if handles.MethodEn(3)&(handles.SigGenerated)
    set(handles.lambdaLog_Text          , 'Enable'          , 'on' )
    set(handles.lambdaLog_ValText       , 'Enable'          , 'on' )
else
    set(handles.lambdaLog_Text          , 'Enable'          , 'off')
    set(handles.lambdaLog_ValText       , 'Enable'          , 'off')
end
if handles.MethodEn(4)&(handles.SigGenerated)
    set(handles.lambdaL1_Text           , 'Enable'          , 'on' )
    set(handles.lambdaL1_ValText        , 'Enable'          , 'on' )
else
    set(handles.lambdaL1_Text           , 'Enable'          , 'off')
    set(handles.lambdaL1_ValText        , 'Enable'          , 'off')
end



% single run panel
chk_LMMSE       = (handles.MethodEn(2) == 0)||pnumcheck(handles.LMMSELambda);
chk_Log         = (handles.MethodEn(3) == 0)||pnumcheck(handles.LogLambda);
chk_L1          = (handles.MethodEn(4) == 0)||pnumcheck(handles.L1Lambda);
if (handles.SigGenerated)&(sum(handles.MethodEn)>0)&(chk_LMMSE)&(chk_Log)&(chk_L1)
    set(handles.SingleRun_Panel     , 'ForegroundColor' , 'k')
    if handles.Operator > 1
        set(handles.MMSE_dB_Text    , 'Enable'      , 'off')
        if handles.MethodEn(3) == 1
            set(handles.Log_dB_Text     , 'Enable'      , 'on')
        else
            set(handles.Log_dB_Text     , 'Enable'      , 'off')
        end
        if handles.MethodEn(2) == 1 
            set(handles.LMMSE_dB_Text   , 'Enable'      , 'on')
        else
            set(handles.LMMSE_dB_Text   , 'Enable'      , 'off')
        end
        if handles.MethodEn(4) == 1
            set(handles.L1_dB_Text      , 'Enable'      , 'on')
        else
            set(handles.L1_dB_Text      , 'Enable'      , 'off')
        end
        
        
    else
        if handles.MethodEn(1) == 1
            set(handles.MMSE_dB_Text    , 'Enable'      , 'on')
        else
            set(handles.MMSE_dB_Text    , 'Enable'      , 'off')
        end
        if handles.MethodEn(3) == 1
            set(handles.Log_dB_Text     , 'Enable'      , 'on')
        else
            set(handles.Log_dB_Text     , 'Enable'      , 'off')
        end
        if handles.MethodEn(2) == 1 
            set(handles.LMMSE_dB_Text   , 'Enable'      , 'on')
        else
            set(handles.LMMSE_dB_Text   , 'Enable'      , 'off')
        end
        if handles.MethodEn(4) == 1
            set(handles.L1_dB_Text      , 'Enable'      , 'on')
        else
            set(handles.L1_dB_Text      , 'Enable'      , 'off')
        end
    end
    
else
    set(handles.SingleRun_Panel     , 'ForegroundColor' , [0.5,0.5,0.5])
    set(handles.MMSE_dB_Text        , 'Enable'          , 'off')
    set(handles.Log_dB_Text         , 'Enable'          , 'off')
    set(handles.LMMSE_dB_Text       , 'Enable'          , 'off')
    set(handles.L1_dB_Text          , 'Enable'          , 'off')
    
    
end
if ~handles.SigDenoised
    set(handles.MMSE_dB_Text        , 'String'      , sprintf('  MMSE --> ... dB') )
    set(handles.LMMSE_dB_Text       , 'String'      , sprintf('LMMSE --> ... dB') )
    set(handles.Log_dB_Text         , 'String'      , sprintf('      Log --> ... dB') )
    set(handles.L1_dB_Text          , 'String'      , sprintf('        L1 --> ... dB') )
end



% Single Run Push Button
if (handles.SigGenerated)&(sum(handles.MethodEn)>0)&chk_LMMSE&chk_Log&chk_L1
    set(handles.Denoise_PushButton     , 'Enable' , 'on'  , 'BackgroundColor' , [0,1,0])
else
    set(handles.Denoise_PushButton     , 'Enable' , 'off' , 'BackgroundColor' , [0.9,0.9,0.9])
end



% Performance Comparison Panel
if (handles.SigGen_En)&(sum(handles.MethodEn)>0)
    set(handles.PerfComp_Panel              , 'ForegroundColor' , 'k')
    set(handles.NoRealz_Text                , 'Enable'          , 'on')
    set(handles.NoRealz_ValText             , 'Enable'          , 'on')
    set(handles.PerfCompAWGNvar_Text        , 'Enable'          , 'on')
    set(handles.PerfComp_AWGNvarL_ValText   , 'Enable'          , 'on')
    set(handles.Text_to_Text                , 'Enable'          , 'on')
    set(handles.PerfComp_AWGNvarU_ValText   , 'Enable'          , 'on')
    
    if integercheck(handles.NumRealz)&pnumcheck(handles.AWGN_varL)&pnumcheck(handles.AWGN_varU)
        if handles.AWGN_varL > handles.AWGN_varU
            set(handles.PerfComp_AWGNvarU_ValText   , 'String'  , num2str(handles.AWGN_varL))
            handles.AWGN_varU   = handles.AWGN_varL;
        end

        set(handles.Compare_PushButton      , 'Enable'  , 'on'  , 'BackgroundColor' , [0,1,0])
        set(handles.Compl_Percentage_Text   , 'Enable'  , 'on')
        
    else
        set(handles.Compare_PushButton      , 'Enable'  , 'off' , 'BackgroundColor' , [0.9,0.9,0.9])
        set(handles.Compl_Percentage_Text   , 'Enable'  , 'off')
    end
        
    
else
    set(handles.PerfComp_Panel              , 'ForegroundColor' , [0.5,0.5,0.5])

    set(handles.NoRealz_Text                , 'Enable'          , 'off')
    set(handles.NoRealz_ValText             , 'Enable'          , 'off')


    set(handles.PerfCompAWGNvar_Text        , 'Enable'          , 'off')
    
    set(handles.PerfComp_AWGNvarL_ValText   , 'Enable'          , 'off')
    set(handles.Text_to_Text                , 'Enable'          , 'off')
    set(handles.PerfComp_AWGNvarU_ValText   , 'Enable'          , 'off')

    set(handles.Compare_PushButton          , 'Enable'          , 'off' , 'BackgroundColor' , [0.9,0.9,0.9])
    set(handles.Compl_Percentage_Text       , 'Enable'          , 'off')
end


